diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index bd0ea8cdb..6f50c6fa1 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -32,7 +32,8 @@ import net.minecraft.client.gui.error.ScreenOutOfMemory;
 import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.client.gui.toasts.GuiElementToastsHud;
 import net.minecraft.client.holiday.Holidays;
-import net.minecraft.client.util.debug.GLFWLoggerCallback;
+import net.minecraft.client.player.controller.PlayerControllerSP;
+import net.minecraft.client.world.save.SaveHandlerClientSP;
 import net.minecraft.core.net.CertificateHelper;
 import net.minecraft.client.net.handler.PacketHandlerClient;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
@@ -84,6 +85,9 @@ import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.LoggedPrintStream;
 import net.minecraft.core.util.helper.UUIDHelper;
+import net.minecraft.core.world.save.SaveFormatBase;
+import net.minecraft.core.world.save.SaveHandlerBase;
+import net.minecraft.core.world.settings.WorldConfiguration;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypeGroups;
 
@@ -98,7 +102,6 @@ import org.jetbrains.annotations.Nullable;
 
 import org.lwjgl.LWJGLException;
 import org.lwjgl.glfw.GLFW;
-import org.lwjgl.glfw.GLFWErrorCallback;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
@@ -291,7 +294,7 @@ public class Minecraft
      * Do not display the ingame crash handler until this is set to true
      */
     private boolean gameStarted = false;
-    private int mojrand = new Random(System.currentTimeMillis()).nextInt(200);
+    private final int mojrand = new Random(System.currentTimeMillis()).nextInt(200);
     public TerrainRenderer terrainRenderer;
 
     private static final TimeKeeper STARTUP_TIKE_KEEPER = new TimeKeeper();
@@ -357,7 +360,7 @@ public class Minecraft
                     try {
                         Thread.sleep(2147483647L);
                     }
-                    catch (final InterruptedException ex) {}
+                    catch (final InterruptedException ignored) {}
                 }
             }
         };
@@ -516,7 +519,9 @@ public class Minecraft
 
         resolution.setScale(gameSettings.guiScale.value);
 
-		saveFormat = new SaveFormat19134(new File(mcDataDir, "saves"));
+        SaveFormatBase handlerBase = new SaveFormat19134(new File(mcDataDir, "saves"));
+        handlerBase.factory = SaveHandlerClientSP::new;
+		saveFormat = handlerBase;
 		I18n.initialize(gameSettings.language.value);
 
 		if (!gameSettings.startInFullscreen.value) {
@@ -955,33 +960,30 @@ public class Minecraft
 
 	public void shutdownMinecraftApplet() {
 		// This could be called very early if the game crashes, so everything could be null!
-		try {
-			try {
-				if(gameSettings != null) {
-					gameSettings.saveOptions();
-				}
-			}catch (Exception e) {
-                LOGGER.error("Exception occurred while saving settings! Some settings may be lost!", e);
-			}
-			if(statsCounter != null) {
-                statsCounter.fetchStats();
-				statsCounter.saveStats();
-			}
-            LOGGER.info("Stopping!");
-			try {
-				changeWorld(null);
-			}catch (Throwable ignored) {
-			}
-			try {
-				GLAllocation.deleteTexturesAndDisplayLists();
-			}catch (Throwable ignored) {
-			}
-			if(sndManager != null) {
-				sndManager.destroy();
-			}
-		}finally {
-		}
-		System.gc();
+        try {
+            if(gameSettings != null) {
+                gameSettings.saveOptions();
+            }
+        } catch (Exception e) {
+            LOGGER.error("Exception occurred while saving settings! Some settings may be lost!", e);
+        }
+        if(statsCounter != null) {
+            statsCounter.fetchStats();
+            statsCounter.saveStats();
+        }
+        LOGGER.info("Stopping!");
+        try {
+            changeWorld(null);
+        }catch (Throwable ignored) {
+        }
+        try {
+            GLAllocation.deleteTexturesAndDisplayLists();
+        }catch (Throwable ignored) {
+        }
+        if(sndManager != null) {
+            sndManager.destroy();
+        }
+        System.gc();
 		if(!hasCrashed) {
 			System.exit(0);
 		}
@@ -1002,43 +1004,33 @@ public class Minecraft
         {
             long currentTime = System.currentTimeMillis();
             int fpsCounter = 0;
-            do
-            {
-                if(!running)
-                {
-                    break;
-                }
+            while (running) {
+                try {
+                    Debug.reset();
+                    Debug.push("update");    // 1
+                    Debug.push("misc");        // 2
 
-                try
-                {
-                	Debug.reset();
-                	Debug.push("update");	// 1
-                	Debug.push("misc");		// 2
-                	
-					long tickStartTime = System.currentTimeMillis();
+                    long tickStartTime = System.currentTimeMillis();
                     Time.tick();
                     ObjectPool.resetAllPools();
 
-                    if(gameWindow.shouldClose()) shutdown();
-                    if(isGamePaused && currentWorld != null && !(currentScreen instanceof ScreenModelViewer))
-                    {
+                    if (gameWindow.shouldClose()) shutdown();
+                    if (isGamePaused && currentWorld != null && !(currentScreen instanceof ScreenModelViewer)) {
                         float temp = timer.partialTicks;
                         timer.advanceTime();
                         timer.partialTicks = temp;
-                    } else
-                    {
+                    } else {
                         timer.advanceTime();
                     }
                     if (!doPartialTick) timer.partialTicks = 1f;
 
                     mouseInput.update();
-                    if(controllerInput != null && currentScreen != null)
-                    {
+                    if (controllerInput != null && currentScreen != null) {
                         controllerInput.moveCursor();
                     }
-                    
-                    Debug.pop();			// 2
-                	Debug.change("tick");	// 1
+
+                    Debug.pop();            // 2
+                    Debug.change("tick");    // 1
                     if (currentWorld instanceof WorldClientMP) {
                         ((WorldClientMP) currentWorld).processPackets();
                     }
@@ -1047,25 +1039,21 @@ public class Minecraft
                         this.currentScreen.tick();
                     }
 
-                    for(int tick = 0; tick < timer.frames; tick++)
-                    {
+                    for (int tick = 0; tick < timer.frames; tick++) {
                         ticksRan++;
-                        try
-                        {
+                        try {
                             runTick();
                             continue;
-                        }
-                        catch(MinecraftException e)
-                        {
+                        } catch (MinecraftException e) {
                             currentWorld = null;
                             LOGGER.error("MinecraftException occurred while attempting to run tick, exiting world!", e);
                         }
                         changeWorld(null);
                         displayScreen(new ScreenConflictWarning());
                     }
-                    
+
                     Debug.change("update"); // 1
-                    Debug.push("misc");		// 2
+                    Debug.push("misc");        // 2
 
                     OpenGLHelper.checkError("pre render");
                     BlockModelGrass.fancyGrass = gameSettings.fancyGraphics.value == 1;
@@ -1073,9 +1061,8 @@ public class Minecraft
                     BlockLogicLeavesBase.enableTreeShadowing = gameSettings.treeShadows.value;
                     sndManager.updateListener(thePlayer, timer.partialTicks);
                     glEnable(GL_TEXTURE_2D);
-                    if(currentWorld != null)
-                    {
-                    	Debug.change("updatelight");
+                    if (currentWorld != null) {
+                        Debug.change("updatelight");
                         try {
                             currentWorld.updatingLighting();
                         } catch (Throwable t) {
@@ -1083,18 +1070,17 @@ public class Minecraft
                         }
                         Debug.change("misc");
                     }
-                    
-                    
+
+
                     Debug.change("misc"); // 2
-                    
-                    if(thePlayer != null && thePlayer.isInWall())
-                    {
+
+                    if (thePlayer != null && thePlayer.isInWall()) {
                         gameSettings.thirdPersonView.value = 0;
                     }
 
                     Debug.change("displayupdate"); // 2
                     gameWindow.update();
-                    
+
                     Debug.change("render"); // 2
                     Debug.push("post"); // 3
 
@@ -1102,21 +1088,19 @@ public class Minecraft
                     glEnable(GL_ALPHA_TEST);
 
                     Debug.change("misc");  // 3
-                    if(!skipRenderWorld)
-                    {
-                        if(playerController != null)
-                        {
+                    if (!skipRenderWorld) {
+                        if (playerController != null) {
                             playerController.render(timer.partialTicks);
                         }
                         worldRenderer.updateCameraAndRender(timer.partialTicks);
                     }
-                    
-                    if(gameSettings.pauseOnLostFocus.value) {
-                        if(!gameWindow.isFocused()) {
-                            if(System.currentTimeMillis() > lastFocusTime + 250) {
+
+                    if (gameSettings.pauseOnLostFocus.value) {
+                        if (!gameWindow.isFocused()) {
+                            if (System.currentTimeMillis() > lastFocusTime + 250) {
                                 displayInGameMenu();
                             }
-                        }else {
+                        } else {
                             lastFocusTime = System.currentTimeMillis();
                         }
                     }
@@ -1124,9 +1108,9 @@ public class Minecraft
 
                     switch (downloadResourcesThread.downloading) {
                         case DOWNLOADING: {
-                            double b = java.lang.Math.sin((System.currentTimeMillis() / 1000.0) * 4);
+                            double b = Math.sin((System.currentTimeMillis() / 1000.0) * 4);
                             b = b * 0.2 + 0.8;
-                            int ib = (int) java.lang.Math.round(b * 255);
+                            int ib = (int) Math.round(b * 255);
                             int color = 0xFF000000 | (ib << 16) | (ib << 8) | (ib);
 
                             int barColor = Color.doubleToIntARGB(1, 0.5 * b, 1.0 * b, 0.5 * b);
@@ -1168,31 +1152,30 @@ public class Minecraft
 
                     Debug.change("post");  // 3
                     renderer.endRenderGame(timer.partialTicks);
-                    
-                    Debug.pop();	// 3
-                    
-                    
+
+                    Debug.pop();    // 3
+
+
                     Debug.change("misc");
-                    
-                    if(gameWindow.wasResized()) {
+
+                    if (gameWindow.wasResized()) {
                         resize();
                     }
                     OpenGLHelper.checkError("post render");
                     fpsCounter++;
                     isGamePaused = !isMultiplayerWorld() && currentScreen != null && currentScreen.isPauseScreen();
-                    while(System.currentTimeMillis() >= currentTime + 1000L)
-                    {
+                    while (System.currentTimeMillis() >= currentTime + 1000L) {
                         debug = fpsCounter + " fps, " + ChunkRenderer.updates + " chunk updates";
                         debugFPS = fpsCounter + " fps";
                         ChunkRenderer.updates = 0;
                         currentTime += 1000L;
                         fpsCounter = 0;
                     }
-					if(currentWorld == null) {
-						long now = System.currentTimeMillis();
-						// Limit FPS in menu
-						long sleepTime = (1000 / 60 - (now - tickStartTime)) - 1;
-						if(sleepTime > 0) {
+                    if (currentWorld == null) {
+                        long now = System.currentTimeMillis();
+                        // Limit FPS in menu
+                        long sleepTime = (1000 / 60 - (now - tickStartTime)) - 1;
+                        if (sleepTime > 0) {
                             long currentSleep = 0;
                             while (currentSleep < sleepTime - 1) {
                                 Thread.sleep(1L);
@@ -1205,31 +1188,25 @@ public class Minecraft
                                     this.currentScreen.tick();
                                 }
                             }
-						}
-					}
-					
-					Debug.pop();	// 2
-					Debug.pop();	// 1
-					if(gameSettings.showFrameTimes.value) {
-						DebugRender.render(font);
-					}
-					
+                        }
+                    }
+
+                    Debug.pop();    // 2
+                    Debug.pop();    // 1
+                    if (gameSettings.showFrameTimes.value) {
+                        DebugRender.render(font);
+                    }
+
                     screenshotListener();
-                }
-                catch(MinecraftException minecraftexception)
-                {
+                } catch (MinecraftException minecraftexception) {
                     currentWorld = null;
                     changeWorld(null);
                     displayScreen(new ScreenConflictWarning());
-                }
-                catch(OutOfMemoryError outofmemoryerror)
-                {
+                } catch (OutOfMemoryError outofmemoryerror) {
                     freeUpMemory();
                     displayScreen(new ScreenOutOfMemory());
                     System.gc();
-                }
-                catch(Throwable throwable)
-                {
+                } catch (Throwable throwable) {
                     if (currentWorld != null) {
                         try {
                             changeWorld(null);
@@ -1238,9 +1215,9 @@ public class Minecraft
                         }
                     }
                     freeUpMemory();
-                    onMinecraftCrash(new UnexpectedThrowable("Unexpected error", throwable));	
+                    onMinecraftCrash(new UnexpectedThrowable("Unexpected error", throwable));
                 }
-            } while(true);
+            }
         }
         catch(MinecraftError ignored) { }
         finally {
@@ -1343,9 +1320,9 @@ public class Minecraft
         }
     }
 
-    private void mineBlocks(int i, boolean flag)
+    private void mineBlocks(int mouseButton, boolean leftClickDown)
     {
-        if(flag && objectMouseOver != null && objectMouseOver.hitType == HitResult.HitType.TILE && i == 0)
+        if(leftClickDown && objectMouseOver != null && objectMouseOver.hitType == HitResult.HitType.TILE && mouseButton == 0)
         {
             int blockX = objectMouseOver.x;
             int blockY = objectMouseOver.y;
@@ -1364,7 +1341,7 @@ public class Minecraft
         }
         else
         {
-            playerController.stopDestroyBlock(flag);
+            playerController.stopDestroyBlock(leftClickDown);
         }
     }
 
@@ -1379,7 +1356,7 @@ public class Minecraft
                 if (clickType == 1) {
                     if (thePlayer.xRot < 45) {break bridge;}
                     List<AABB> cubes = thePlayer.world.getCubes(thePlayer, thePlayer.bb.cloneMove(0, -1.0, 0.0));
-                    if (cubes.size() < 1){break bridge;}
+                    if (cubes.isEmpty()){break bridge;}
                     AABB cube = cubes.get(0);
                     if (cube == null){break bridge;}
                     int blockX = MathHelper.floor(thePlayer.x);
@@ -2198,6 +2175,7 @@ public class Minecraft
     }
     
     public void handleControllerInput() {
+        assert controllerInput != null;
         try{
             controllerInput.update();
         }catch (Exception e) {
@@ -2296,12 +2274,39 @@ public class Minecraft
         return currentWorld != null && currentWorld.isClientSide;
     }
 
-    public void startWorld(String worldDirName, String worldName, long seed)
-    {
-        startWorld(worldDirName, worldName, seed, null);
+    public void createAndStartWorld(final @NotNull WorldConfiguration worldConfiguration) {
+        final @NotNull LevelStorage levelStorage = this.saveFormat.getSaveHandler(worldConfiguration.getFolderName(this.saveFormat), false);
+        for (final @NotNull Dimension dimension : Dimension.getDimensionList().values()) {
+            final @Nullable WorldType worldType = worldConfiguration.getWorldTypeGroup().get(dimension);
+            if (worldType != null) {
+                final @NotNull DimensionData data = new DimensionData(worldType);
+                levelStorage.saveDimensionData(dimension.id, data);
+            }
+        }
+
+        final @NotNull WorldClient world = new WorldClient(
+                levelStorage,
+                worldConfiguration.getFinalWorldName(),
+                worldConfiguration.getFinalNumericSeed(),
+                Dimension.OVERWORLD,
+                null
+        );
+        world.getLevelData().setCheatsEnabled(worldConfiguration.getCheatsEnabled());
+
+        this.statsCounter.add(StatList.createWorldStat, 1);
+        this.statsCounter.add(StatList.startGameStat, 1);
+
+        this.playerController = new PlayerControllerSP(this);
+
+        changeWorld(world, I18n.getInstance().translateKey("gui.loading.label.generating"));
+
+        this.thePlayer.setGamemode(worldConfiguration.getGamemode());
+        if (worldConfiguration.getGamemode() == Gamemode.adventure) {
+            this.thePlayer.inventory.insertItem(Items.TOOL_AXE_WOOD.getDefaultStack(), true);
+        }
     }
 
-    public void startWorld(String worldDirName, String worldName, long seed, WorldTypeGroups.Group worldTypeGroup)
+    public void startWorld(String worldDirName)
     {
         changeWorld(null);
         System.gc();
@@ -2320,38 +2325,22 @@ public class Minecraft
 
         if(worldSaveVersion < CURRENT_SAVE_VERSION)
         {
-            convertSaveVersion(worldSaveVersion, worldDirName, worldName);
+            convertSaveVersion(worldSaveVersion, worldDirName);
         }
         else
         {
             I18n i18n = I18n.getInstance();
             LevelStorage saveHandler = saveFormat.getSaveHandler(worldDirName, false);
-            if (worldTypeGroup != null) {
-                for (Dimension dimension : Dimension.getDimensionList().values()) {
-                    WorldType worldType = worldTypeGroup.get(dimension);
-                    if (worldType != null) {
-                        DimensionData data = saveHandler.getDimensionData(dimension.id);
-                        if (data == null) {
-                            data = new DimensionData(worldType);
-                        } else {
-                            data.setWorldType(worldType);
-                        }
-                        saveHandler.saveDimensionData(dimension.id, data);
-                    }
-                }
-            }
-            WorldClient world = new WorldClient(saveHandler, worldName, seed, null, null);
-            if(world.isNewWorld)
-            {
-                statsCounter.add(StatList.createWorldStat, 1);
-                statsCounter.add(StatList.startGameStat, 1);
-                changeWorld(world, i18n.translateKey("gui.loading.label.generating"));
-            } else
-            {
-                statsCounter.add(StatList.loadWorldStat, 1);
-                statsCounter.add(StatList.startGameStat, 1);
-                changeWorld(world, i18n.translateKey("gui.loading.label.loading"));
+            Dimension dimension = null;
+            CompoundTag tag = saveHandler.getPlayerData(session.username, session.uuid);
+            if (tag != null) {
+                dimension = Dimension.getDimensionList().get(tag.getInteger("Dimension"));
             }
+
+            WorldClient world = new WorldClient(saveHandler, null, 0L, dimension, null);
+            statsCounter.add(StatList.loadWorldStat, 1);
+            statsCounter.add(StatList.startGameStat, 1);
+            changeWorld(world, i18n.translateKey("gui.loading.label.loading"));
         }
     }
 
@@ -2416,7 +2405,7 @@ public class Minecraft
         changeWorld(world, loadingTitle, null);
     }
 
-    public void changeWorld(WorldClient world, String loadingTitle, Player player)
+    public void changeWorld(WorldClient world, String loadingTitle, @Nullable Player player)
     {
     	mainMenuBackground.deleteTextures();
     	gameSettings.showCollisionBoxes.value = false;
@@ -2449,6 +2438,9 @@ public class Minecraft
                 }
                 currentWorld.getChunkProvider().unloadAllChunks();
                 currentWorld.onUnload();
+                if (player != null) {
+                    currentWorld.saveHandler.save(player);
+                }
             }
         }
         currentWorld = world;
@@ -2462,7 +2454,7 @@ public class Minecraft
             {
                 if(player == null)
                 {
-                    thePlayer = (PlayerLocal)world.findSubclassOf(PlayerLocal.class);
+                    thePlayer = null;
                 }
             }
             else if(thePlayer != null)
@@ -2494,7 +2486,7 @@ public class Minecraft
             int i = MathHelper.floor_float((int)thePlayer.x) >> 4;
             int j = MathHelper.floor_float((int)thePlayer.z) >> 4;
             ichunkprovider.setCurrentChunkOver(i, j);
-            world.spawnPlayerWithLoadedChunks(thePlayer);
+            world.spawnPlayerWithLoadedChunks(thePlayer, false);
             if(world.isNewWorld)
             {
                 world.saveWorldIndirectly(loadingScreen);
@@ -2513,7 +2505,7 @@ public class Minecraft
         worldRenderer.lightmapHelper.setup();
     }
 
-    private void convertSaveVersion(int fromVersion, String worldDirName, String worldName)
+    private void convertSaveVersion(int fromVersion, String worldDirName)
     {
         ISaveFormat fromWorldFormat = SaveFormats.createSaveFormat(fromVersion, new File(mcDataDir, "saves"));
 
@@ -2553,7 +2545,7 @@ public class Minecraft
                     LevelStorage saveHandler = toWorldFormat.getSaveHandler(worldDirName, false);
                     saveHandler.saveLevelDataRaw(levelDataTag);
 
-                    startWorld(worldDirName, worldName, 0L);
+                    startWorld(worldDirName);
                 }
             }
         }
@@ -2679,7 +2671,7 @@ public class Minecraft
         }
         thePlayer.setLastDeathCoordinate(lastDeathCoordinates);
         playerController.initPlayer(thePlayer);
-        currentWorld.spawnPlayerWithLoadedChunks(thePlayer);
+        currentWorld.spawnPlayerWithLoadedChunks(thePlayer, true);
         thePlayer.input = new PlayerInput(this);
         thePlayer.id = j;
         thePlayer.animate4();
@@ -2720,11 +2712,9 @@ public class Minecraft
 
         sessionId = sessionId == null ? "" : sessionId;
         if (uuid == null || !UUIDHelper.isUUID(uuid)) {
-            if (username != null) {
-                UUID nameUUID = UUIDHelper.getUUIDFromName(username);
-                if (nameUUID != null) {
-                    uuid = nameUUID.toString();
-                }
+            UUID nameUUID = UUIDHelper.getUUIDFromName(username);
+            if (nameUUID != null) {
+                uuid = nameUUID.toString();
             }
             if (uuid == null) {
                 uuid = "00000000-0000-0000-0000-000000000000";
@@ -2750,7 +2740,7 @@ public class Minecraft
         ImageIO.setUseCache(false); // Speeds up boot time
         checkLwjglVersion();
         if (isClientASteamDeck()) {
-            System.out.println("Client is a Steam Deck!");
+            LOGGER.info("Client is a Steam Deck!");
         }
 
         String playerName = null;
@@ -2770,7 +2760,7 @@ public class Minecraft
                         playerName = args[pointer + 1];
                         pointer++;
                     } catch (Exception e) {
-                        e.printStackTrace();
+                        LOGGER.error("", e);
                     }
                     pointer++;
                     break;
@@ -2780,7 +2770,7 @@ public class Minecraft
                         sessionId = args[pointer + 1];
                         pointer++;
                     } catch (Exception e) {
-                        e.printStackTrace();
+                        LOGGER.error("", e);
                     }
                     pointer++;
                     break;
@@ -2790,7 +2780,7 @@ public class Minecraft
                         uuid = args[pointer + 1];
                         pointer++;
                     } catch (Exception e) {
-                        e.printStackTrace();
+                        LOGGER.error("", e);
                     }
                     pointer++;
                     break;
@@ -2800,7 +2790,7 @@ public class Minecraft
                         gameDirectory = new File(args[pointer + 1]);
                         pointer++;
                     } catch (Exception e) {
-                        e.printStackTrace();
+                        LOGGER.error("", e);
                     }
                     pointer++;
                     break;
@@ -2810,7 +2800,7 @@ public class Minecraft
                         server = args[pointer + 1];
                         pointer++;
                     } catch (Exception e) {
-                        e.printStackTrace();
+                        LOGGER.error("", e);
                     }
                     pointer++;
                     break;
@@ -2820,7 +2810,7 @@ public class Minecraft
                         port = Integer.parseInt(args[pointer + 1]);
                         pointer++;
                     } catch (Exception e) {
-                        e.printStackTrace();
+                        LOGGER.error("", e);
                     }
                     pointer++;
                     break;
@@ -2830,7 +2820,7 @@ public class Minecraft
                         width = Integer.parseInt(args[pointer + 1]);
                         pointer++;
                     } catch (Exception e) {
-                        e.printStackTrace();
+                        LOGGER.error("", e);
                     }
                     pointer++;
                     break;
@@ -2840,7 +2830,7 @@ public class Minecraft
                         height = Integer.parseInt(args[pointer + 1]);
                         pointer++;
                     } catch (Exception e) {
-                        e.printStackTrace();
+                        LOGGER.error("", e);
                     }
                     pointer++;
                     break;
